#include "dialog.h"
#include "ui_dialog.h"

Dialog::Dialog(QWidget *parent): QDialog(parent), ui(new Ui::Dialog) {
 ui->setupUi(this);
 list = new QStringList();
 popUp = new PopUp();
 this->value = 0;
 connect (this,SIGNAL(listChanged()),this,SLOT(listChangedSlot()));
 connect (this,SIGNAL(listChanged()),this,SLOT(listChangedSlot()));
}

void Dialog::on_pushButton_clicked() { //Add
 int val = ui->spinBox->value();
 QString strval = QString::number(val);
 bool uniqueItem = false;
 if (!list->contains(strval)) {
  list->append(strval);
  uniqueItem = true;
  emit listChanged();
 }
 popUp->setPopupText(
  QString(uniqueItem ? "Добавлено: %1" : "%1 уже есть в списке").arg(this->value)
 );
 popUp->show();
}

void Dialog::on_pushButton_2_clicked() { //Delete
 int val = ui->spinBox->value();
 QString strval = QString::number(val);
 int pos = list->indexOf(strval);
 bool foundItem = false;
 if (list->contains(strval)) {
  list->removeAt(pos);
  foundItem = true;
  emit listChanged();
 }
 popUp->setPopupText(
  QString(foundItem ? "Удалено: %1" : "%1 не найдено в списке").arg(this->value)
 );
 popUp->show();
}

void Dialog::listChangedSlot() { //Slot for view
 ui->textEdit->clear(); ui->textEdit->append(list->join("\n"));
}

void Dialog::on_spinBox_valueChanged(int arg1) {
 this->value = arg1;
 popUp->setPopupText(QString("Выбрано значение: %1").arg(this->value));
 popUp->show();
}

Dialog::~Dialog() { delete ui; }
